#include <iostream>
#include <fstream>
#include <cstdlib>
#include <ctime>

#include <boost/random.hpp>
#include <boost/timer/timer.hpp>

using namespace std;
using namespace boost;

int main ( int argc, char **argv ) {
//int _tmain( int argc, _TCHAR* argv[] ) {

   unsigned long blksize = 1024 * 1024,     //   
                 blknumb,                   //     
                 wrnumb = 100;              //       
   locale::global( locale( "" ) );
   if( 1 == argc ) { 
      cout << ":  " << argv[ 0 ] << "  [ ] [  [{K,M}]]" << endl;
      exit( EXIT_SUCCESS );
   }
   if( argc > 2 && atoi( argv[ 2 ] ) > 0 ) wrnumb = atoi( argv[ 2 ] );
   if( argc > 3 && atoi( argv[ 3 ] ) > 0 ) {
      blksize = atoi( argv[ 3 ] );
      char c = argv[ 3 ][ strlen( argv[ 3 ] ) - 1 ];
      if( 'K' == c || 'k' == c ) blksize *= 1024L;
      if( 'M' == c || 'm' == c ) blksize *= 1024L * 1024L;
   }

   char *block = new char[ blksize ];       //   
   for( unsigned int i = 0; i < blksize; ++i ) block[ i ] = i & 0xFF;
   ofstream to( argv[ 1 ],                  //   
                ios_base::in | ios_base::out | ios_base::ate );
   if( !to ) perror( " " ), exit( EXIT_FAILURE );
   unsigned long long flength;

   to.seekp( 0, ios_base::end );
   flength = to.tellp();
   blknumb = flength / blksize;
   cout << "  " << flength << ",    " << blknumb << endl;
   bool *indic = new bool[ blknumb ];       //   
   for( unsigned long i = 0; i < blknumb; ++i ) indic[ i ] = false;


   mt19937 rng;                             //    
// mt11213b rnd; 
// ~30    boost  :
// http://www.boost.org/doc/libs/1_53_0/doc/html/boost_random/reference.html
   rng.seed( static_cast<unsigned>( std::time( 0 ) ) ); //      1970 
   /* mt19937 produces integers in the range [0, 2^32-1].
      However, we want numbers in the range [0, blknumb - 1].
      The distribution uniform_int_distribution performs this transformation. 
      Given the parameters 0 and blknumb - 1, uniform_int_distribution 
      can produce any of the values 0, 1, 2, ... blknumb - 1. */
   random::uniform_int_distribution<> dist( 0, blknumb - 1 ); //   

   cout << "   :" << endl;
   {  boost::timer::auto_cpu_timer t;
      for( unsigned long i = 0; i < wrnumb; ++i ) {
         unsigned long nblk = dist( rng );  //    
         to.seekp( nblk * blksize, ios_base::beg );
         to.write( block, blksize );
         if( !to ) perror( "  " ), exit( EXIT_FAILURE );
         to.flush();
         indic[ nblk ] = true;
      }
   }
   cout << "     " << wrnumb << "   " << blksize << "  " << endl;

   unsigned long nmod = 0;
   for( unsigned long i = 0; i < blknumb; ++i ) nmod += indic[ i ] ? 1 : 0;
   cout << " " << blknumb << "    " << nmod << " " << endl;

   to.seekp( 0, ios_base::end );
   flength = to.tellp();
   cout << "   : " << flength << endl;
   to.close();
   delete [] block;
   exit( EXIT_SUCCESS );
} 

